# correct count of item in storage
data modify storage customsus:temp Item set from entity @s Inventory[{components:{"minecraft:custom_data":{customsus:1b}}}]
data modify storage customsus:temp Item.count set from storage customsus:temp Item.components.minecraft:custom_data.customsus_count

# check for extra components
execute store result score components customsus.temp run data get storage customsus:temp Item.components
execute store result score custom_data customsus.temp run data get storage customsus:temp Item.components.minecraft:custom_data

# prepare components
execute if score components customsus.temp matches 1 if score custom_data customsus.temp matches 2 run data remove storage customsus:temp Item.components
execute if score components customsus.temp matches 2.. if score custom_data customsus.temp matches 2 run data remove storage customsus:temp Item.components.minecraft:custom_data
execute if score custom_data customsus.temp matches 3.. run data remove storage customsus:temp Item.components.minecraft:custom_data.customsus
execute if score custom_data customsus.temp matches 3.. run data remove storage customsus:temp Item.components.minecraft:custom_data.customsus_count

# prepare slot for item command in macro
execute store result score slot_index customsus.temp store result score slot_number customsus.temp run data get storage customsus:temp Item.Slot
execute if score slot_index customsus.temp matches 9.. run scoreboard players remove slot_number customsus.temp 9
execute if score slot_index customsus.temp matches 9.. store result storage customsus:temp Item.Slot int 1 run scoreboard players get slot_number customsus.temp

# correct item in inventory depending on components
execute if predicate customsus:has_components run function customsus:bugfix/macro_components with storage customsus:temp Item
execute unless predicate customsus:has_components run function customsus:bugfix/macro_without with storage customsus:temp Item

# repeat if necessary
execute if data entity @s Inventory[{components:{"minecraft:custom_data":{customsus:1b}}}] run function customsus:bugfix/correct_inventory



# doesn't account for combining stacks in the inventory yet